/*
 * This is the main GUI for HD-CNV... Run this for the program!
 * Author: Jenna Butler
 */

//package jennabutler.hdcnv;

import javax.swing.JOptionPane;

/**
 *
 * @author jenna
 */
public class HDCNV_GUI extends javax.swing.JFrame {

	//Added by Jenna
	 String directory = "";
	 double percentOverlap = 40;
	 double familyPercent = 99;
	 boolean graphFiles = true;
	 boolean trackFiles = true;
	 boolean samplesProvided = false;
	 String samples = "";
	 public static boolean extraInfo = false; //boolean for whether they want extra columns carried through
	 public static int extraColumns = 0;
	 public static int numSamples = 0;
	 
    /**
     * Creates new form HDCNV_GUI
     */
    public HDCNV_GUI() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">
    private void initComponents() {

        tabParent = new javax.swing.JTabbedPane();
        tabMain = new javax.swing.JPanel();
        labelPercent = new javax.swing.JLabel();
        labelFamily = new javax.swing.JLabel();
        textPercent = new javax.swing.JTextField();
        textFamiy = new javax.swing.JTextField();
        buttonExit = new javax.swing.JButton();
        buttonGo = new javax.swing.JButton();
        buttonClear = new javax.swing.JButton();
        labelDirectory = new javax.swing.JLabel();
        textDirectory = new javax.swing.JTextField();
        checkUCSCTrack = new javax.swing.JCheckBox();
        checkGraph = new javax.swing.JCheckBox();
        labelRequiredFields = new javax.swing.JLabel();
        tabInput = new javax.swing.JPanel();
        buttonInputData = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        tableSampleInput = new javax.swing.JTable();
        labelInput1 = new javax.swing.JLabel();
        labelInput2 = new javax.swing.JLabel();
        labelInput3 = new javax.swing.JLabel();
        labelInput4 = new javax.swing.JLabel();
        labelInput5 = new javax.swing.JLabel();
        labelInput7 = new javax.swing.JLabel();
        labelInput6 = new javax.swing.JLabel();
        textNumOfColumns = new javax.swing.JTextField();
        radioInputYes = new javax.swing.JRadioButton();
        radioInputNo = new javax.swing.JRadioButton();
        tabExtra = new javax.swing.JPanel();
        labelSampleData = new javax.swing.JLabel();
        textNumSamples = new javax.swing.JTextField();
        labelNumSamples = new javax.swing.JLabel();
        labelSampleInfo1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        textArraySamples = new javax.swing.JTextArea();
        labelSampleInfo2 = new javax.swing.JLabel();
        buttonSampleData = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("HD-CNV: Hotspot Detector of Copy Number Variants");
        setBackground(new java.awt.Color(203, 203, 212));
        setForeground(new java.awt.Color(204, 204, 255));
        setResizable(false);

        tabParent.setBackground(new java.awt.Color(191, 191, 199));

        labelPercent.setText("Percent required for overlap:");

        labelFamily.setText("Percent required for family:");

        textPercent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textPercentActionPerformed(evt);
            }
        });

        textFamiy.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textFamiyActionPerformed(evt);
            }
        });

        buttonExit.setText("Exit");
        buttonExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonExitActionPerformed(evt);
            }
        });

        buttonGo.setText("Run");
        buttonGo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonGoActionPerformed(evt);
            }
        });

        buttonClear.setText("Reset");
        buttonClear.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonClearActionPerformed(evt);
            }
        });

        labelDirectory.setText("Input directory:");

        textDirectory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textDirectoryActionPerformed(evt);
            }
        });
        
        //Adds key binding allowing one to cut/paste into the directory field
        javax.swing.text.Keymap k = textDirectory.getKeymap();
        javax.swing.text.JTextComponent.loadKeymap(k, defaultBindings, textDirectory.getActions());

        checkUCSCTrack.setSelected(true);
        checkUCSCTrack.setText("Generate UCSC Tracks");

        checkGraph.setSelected(true);
        checkGraph.setText("Generate Graph Files");

        labelRequiredFields.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        labelRequiredFields.setText("Hotspot Detection Data");

        org.jdesktop.layout.GroupLayout tabMainLayout = new org.jdesktop.layout.GroupLayout(tabMain);
        tabMain.setLayout(tabMainLayout);
        tabMainLayout.setHorizontalGroup(
            tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabMainLayout.createSequentialGroup()
                .add(24, 24, 24)
                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tabMainLayout.createSequentialGroup()
                        .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(labelFamily)
                            .add(labelDirectory)
                            .add(labelPercent)
                            .add(checkGraph))
                        .add(31, 31, 31)
                        .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(tabMainLayout.createSequentialGroup()
                                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(tabMainLayout.createSequentialGroup()
                                        .add(231, 231, 231)
                                        .add(buttonClear)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(buttonExit))
                                    .add(tabMainLayout.createSequentialGroup()
                                        .add(textDirectory, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 181, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                                        .add(buttonGo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 101, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                                .addContainerGap())
                            .add(tabMainLayout.createSequentialGroup()
                                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(checkUCSCTrack)
                                    .add(textFamiy, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 85, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(textPercent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 85, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .add(0, 0, Short.MAX_VALUE))))
                    .add(tabMainLayout.createSequentialGroup()
                        .add(223, 223, 223)
                        .add(labelRequiredFields)
                        .addContainerGap())))
        );
        tabMainLayout.setVerticalGroup(
            tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabMainLayout.createSequentialGroup()
                .add(18, 18, 18)
                .add(labelRequiredFields)
                .add(32, 32, 32)
                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(textPercent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(labelPercent))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(textFamiy, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(labelFamily))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(labelDirectory)
                    .add(textDirectory, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(buttonGo))
                .add(18, 18, 18)
                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(checkGraph)
                    .add(checkUCSCTrack))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 107, Short.MAX_VALUE)
                .add(tabMainLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(buttonExit)
                    .add(buttonClear))
                .addContainerGap())
        );

        tabParent.addTab("HD-CNV", tabMain);

        buttonInputData.setText("Submit Input");
        buttonInputData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonInputDataActionPerformed(evt);
            }
        });

        tableSampleInput.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                { new Integer(1),  new Integer(1),  new Integer(50),  new Integer(100), "186", "Amp", null},
                { new Integer(2),  new Integer(1),  new Integer(60),  new Integer(105), "187", "Del", null},
                { new Integer(3),  new Integer(1),  new Integer(80),  new Integer(300), "188", "Amp", null}
            },
            new String [] {
                "ID", "Chromosome", "Start", "End", "Sample", "Type", "Extra"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.Integer.class, java.lang.String.class, java.lang.String.class, java.lang.String.class
            };
            boolean[] canEdit = new boolean [] {
                true, true, true, true, true, true, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tableSampleInput.setGridColor(new java.awt.Color(102, 102, 102));
        tableSampleInput.getTableHeader().setReorderingAllowed(false);
        jScrollPane2.setViewportView(tableSampleInput);
        tableSampleInput.getColumnModel().getColumn(0).setResizable(false);
        tableSampleInput.getColumnModel().getColumn(1).setResizable(false);
        tableSampleInput.getColumnModel().getColumn(2).setResizable(false);
        tableSampleInput.getColumnModel().getColumn(3).setResizable(false);
        tableSampleInput.getColumnModel().getColumn(4).setResizable(false);
        tableSampleInput.getColumnModel().getColumn(5).setResizable(false);
        tableSampleInput.getColumnModel().getColumn(6).setResizable(false);

        labelInput1.setText("Here is a sample input file:");

        labelInput2.setText("ID, Chromosome, Start, End, Sample and Type are required columns. Extra means optional columns.");

        labelInput3.setText("Headings must be in the same order as displayed above, and the file must be sorted by starting");

        labelInput4.setText("position. The ID numbers must be unique and should be added once the file is sorted.");

        labelInput5.setText("You may have any number of optional columns, after the required columns.");

        labelInput7.setText("How many columns does the file have in total?");

        labelInput6.setText("Should the optional columns be reprinted in the final output files?");

        textNumOfColumns.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textNumOfColumnsActionPerformed(evt);
            }
        });

        radioInputYes.setText("Yes");

        radioInputNo.setText("No");
        radioInputNo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioInputNoActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabInputLayout = new org.jdesktop.layout.GroupLayout(tabInput);
        tabInput.setLayout(tabInputLayout);
        tabInputLayout.setHorizontalGroup(
            tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabInputLayout.createSequentialGroup()
                .addContainerGap()
                .add(tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tabInputLayout.createSequentialGroup()
                        .add(labelInput7)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(textNumOfColumns, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 63, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(buttonInputData))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, tabInputLayout.createSequentialGroup()
                        .add(jScrollPane2)
                        .addContainerGap())
                    .add(tabInputLayout.createSequentialGroup()
                        .add(tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(labelInput1)
                            .add(labelInput2)
                            .add(labelInput3)
                            .add(tabInputLayout.createSequentialGroup()
                                .add(6, 6, 6)
                                .add(labelInput4))
                            .add(labelInput5)
                            .add(tabInputLayout.createSequentialGroup()
                                .add(labelInput6)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(radioInputYes)
                                .add(18, 18, 18)
                                .add(radioInputNo)))
                        .add(0, 1, Short.MAX_VALUE))))
        );
        tabInputLayout.setVerticalGroup(
            tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabInputLayout.createSequentialGroup()
                .add(26, 26, 26)
                .add(labelInput1)
                .add(18, 18, 18)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(18, 18, 18)
                .add(labelInput2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(labelInput3)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(labelInput4)
                .add(26, 26, 26)
                .add(labelInput5)
                .add(tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tabInputLayout.createSequentialGroup()
                        .add(0, 0, Short.MAX_VALUE)
                        .add(buttonInputData))
                    .add(tabInputLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(labelInput6)
                            .add(radioInputYes)
                            .add(radioInputNo))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(tabInputLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(labelInput7)
                            .add(textNumOfColumns, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(0, 22, Short.MAX_VALUE)))
                .addContainerGap())
        );

        tabParent.addTab("  Input  ", tabInput);

        labelSampleData.setText("Sample data:");

        textNumSamples.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                textNumSamplesActionPerformed(evt);
            }
        });

        labelNumSamples.setText("Number of samples:");

        labelSampleInfo1.setText("For each sample, type the numerical sample ID followed by genotype, tissue type.");

        textArraySamples.setColumns(20);
        textArraySamples.setRows(5);
        textArraySamples.setText("168, wt, cb\n169, hq, sp");
        jScrollPane1.setViewportView(textArraySamples);

        labelSampleInfo2.setText("Each sample should go on its own line.");

        buttonSampleData.setText("Submit Sample Data");
        buttonSampleData.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSampleDataActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout tabExtraLayout = new org.jdesktop.layout.GroupLayout(tabExtra);
        tabExtra.setLayout(tabExtraLayout);
        tabExtraLayout.setHorizontalGroup(
            tabExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabExtraLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(tabExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tabExtraLayout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 617, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .add(tabExtraLayout.createSequentialGroup()
                        .add(tabExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, labelSampleData)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, tabExtraLayout.createSequentialGroup()
                                .add(labelNumSamples)
                                .add(33, 33, 33)
                                .add(textNumSamples, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 63, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(org.jdesktop.layout.GroupLayout.LEADING, labelSampleInfo1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 508, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(org.jdesktop.layout.GroupLayout.LEADING, labelSampleInfo2))
                        .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, tabExtraLayout.createSequentialGroup()
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(buttonSampleData))
        );
        tabExtraLayout.setVerticalGroup(
            tabExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(tabExtraLayout.createSequentialGroup()
                .addContainerGap()
                .add(labelSampleData)
                .add(18, 18, 18)
                .add(tabExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(labelNumSamples)
                    .add(textNumSamples, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(labelSampleInfo1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(labelSampleInfo2)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 77, Short.MAX_VALUE)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 117, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                .add(buttonSampleData)
                .add(4, 4, 4))
        );

        tabParent.addTab("Extra", tabExtra);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tabParent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 650, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(0, 0, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(tabParent, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(0, 0, Short.MAX_VALUE))
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-690)/2, (screenSize.height-500)/2, 690, 500);
        pack();
    }// </editor-fold>

    //JENNA Changed these
    private void textPercentActionPerformed(java.awt.event.ActionEvent evt) {
        percentOverlap = Double.parseDouble(textPercent.getText());
    }

    private void buttonClearActionPerformed(java.awt.event.ActionEvent evt) {
    	 percentOverlap = 40;
         familyPercent = 99;
         directory = "";
         textDirectory.setText("");
         textPercent.setText("");
         textFamiy.setText("");
    }

    private void buttonGoActionPerformed(java.awt.event.ActionEvent evt) {
    	
    	//check for missing data
		if (textPercent.getText().equals("")){
			JOptionPane.showMessageDialog(this, "You have not selected a percent for merges. \n A default of 40% will be used");
			percentOverlap = 40;
		}
		else{
			percentOverlap = Double.parseDouble(textPercent.getText());
		}
		
		
		if (textFamiy.getText().equals("")){
			JOptionPane.showMessageDialog(this, "You have not selected a percent for families. \n A default of 99% will be used");
			familyPercent = 99;
		}
		else{
			familyPercent = Double.parseDouble(textFamiy.getText()); 
		}
		
		
		//Throw an error if no directory
		if (textDirectory.getText().equals("")){
			JOptionPane.showMessageDialog(this,"Please enter a working directory.");
		}
		
    	
		//If they have chosen a directory, move ahead
		else {
			//Get data from fields on this page
	    	
	    	directory = textDirectory.getText();
			
			if (checkGraph.isSelected()){
				graphFiles = true;
			}
			else{
				graphFiles = false;
			}
			if (checkUCSCTrack.isSelected()){
				trackFiles = true;
			}
			else {
				trackFiles = false;
			}
			try{

				BuildGraph.processDirectory(directory, percentOverlap, familyPercent, graphFiles, trackFiles);
				JOptionPane.showMessageDialog(this, "Analysis completed.");

			}
			//JENNA TRY THIS
			catch (HDCNVInputException ie){
				JOptionPane.showMessageDialog(this, ie.getMessage());
			}
			catch (Exception e){
				JOptionPane.showMessageDialog(this, "There was an error processing your files. \n Please check your input and try again \n .");
				e.printStackTrace();
			}
		}   
    }

    private void buttonExitActionPerformed(java.awt.event.ActionEvent evt) {
        System.exit(0);
    }

    //Code goes here for if they set up their input files
    private void buttonInputDataActionPerformed(java.awt.event.ActionEvent evt) {
    	//Determine if you need to carry the extra info forward
		JOptionPane.showMessageDialog(this, "Your input has been received.");
    	if (radioInputYes.isSelected()) {
    		extraInfo = true;
    		extraColumns = Integer.parseInt(textNumOfColumns.getText()) - 6;
    		if (extraColumns == 0){
    			extraInfo = false;
    		}
    	}
    	else {
    		extraInfo = false;
    	}	    	
    }

    private void textFamiyActionPerformed(java.awt.event.ActionEvent evt) {
		familyPercent = Double.parseDouble(textFamiy.getText());        
    }

    private void textDirectoryActionPerformed(java.awt.event.ActionEvent evt) {
		directory = textDirectory.getText();
    }

    private void textNumSamplesActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
    }

    private void buttonSampleDataActionPerformed(java.awt.event.ActionEvent evt) {
		JOptionPane.showMessageDialog(this, "Your sample data has been received.");
		if (textNumSamples.getText() != null){
			samplesProvided = true;
			samples = textArraySamples.getText();
			numSamples = Integer.parseInt(textNumSamples.getText());
			FormatInput.createSampleList(samples);
		}	
    }

    private void textNumOfColumnsActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
    }

    private void radioInputNoActionPerformed(java.awt.event.ActionEvent evt) {
        // TODO add your handling code here:
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        /*try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        }*/
    	try {
			// Set System L&F
			javax.swing.UIManager.setLookAndFeel(
					javax.swing.UIManager.getSystemLookAndFeelClassName());
		}
        catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(HDCNV_GUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(HDCNV_GUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(HDCNV_GUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(HDCNV_GUI.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new HDCNV_GUI().setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify
    private javax.swing.JButton buttonClear;
    private javax.swing.JButton buttonExit;
    private javax.swing.JButton buttonGo;
    private javax.swing.JButton buttonInputData;
    private javax.swing.JButton buttonSampleData;
    private javax.swing.JCheckBox checkGraph;
    private javax.swing.JCheckBox checkUCSCTrack;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel labelDirectory;
    private javax.swing.JLabel labelFamily;
    private javax.swing.JLabel labelInput1;
    private javax.swing.JLabel labelInput2;
    private javax.swing.JLabel labelInput3;
    private javax.swing.JLabel labelInput4;
    private javax.swing.JLabel labelInput5;
    private javax.swing.JLabel labelInput6;
    private javax.swing.JLabel labelInput7;
    private javax.swing.JLabel labelNumSamples;
    private javax.swing.JLabel labelPercent;
    private javax.swing.JLabel labelRequiredFields;
    private javax.swing.JLabel labelSampleData;
    private javax.swing.JLabel labelSampleInfo1;
    private javax.swing.JLabel labelSampleInfo2;
    private javax.swing.JRadioButton radioInputNo;
    private javax.swing.JRadioButton radioInputYes;
    private javax.swing.JPanel tabExtra;
    private javax.swing.JPanel tabInput;
    private javax.swing.JPanel tabMain;
    private javax.swing.JTabbedPane tabParent;
    private javax.swing.JTable tableSampleInput;
    private javax.swing.JTextArea textArraySamples;
    private javax.swing.JTextField textDirectory;
    private javax.swing.JTextField textFamiy;
    private javax.swing.JTextField textNumOfColumns;
    private javax.swing.JTextField textNumSamples;
    private javax.swing.JTextField textPercent;
    // End of variables declaration
    
    
    
    //Key bindings that allow the text box to be copy/cut/paste-able
    //NOTE: This allows both MAC and Windows copy-cut-paste key combos to work.
    //   The key binding "META_MASK" is for the command key of the MAC keyboard
    //   Windows is "CTRL_MASK"
    private static final javax.swing.text.JTextComponent.KeyBinding[] 
 	       defaultBindings = {
 	       new javax.swing.text.JTextComponent.KeyBinding(
 	    		  javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, 
 	    				 java.awt.event.InputEvent.META_MASK),
 	    				javax.swing.text.DefaultEditorKit.copyAction),
 	       new javax.swing.text.JTextComponent.KeyBinding(
 	    		  javax.swing.KeyStroke.getKeyStroke
 	         (java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.META_MASK),
 	        javax.swing.text.DefaultEditorKit.pasteAction),
 	       new javax.swing.text.JTextComponent.KeyBinding(
 	    		  javax.swing.KeyStroke.getKeyStroke
 	         (java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.META_MASK),
 	        javax.swing.text.DefaultEditorKit.cutAction),
 	       new javax.swing.text.JTextComponent.KeyBinding(
  	    		  javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_C, 
  	    				 java.awt.event.InputEvent.CTRL_MASK),
  	    				javax.swing.text.DefaultEditorKit.copyAction),
  	       new javax.swing.text.JTextComponent.KeyBinding(
  	    		  javax.swing.KeyStroke.getKeyStroke
  	         (java.awt.event.KeyEvent.VK_V, java.awt.event.InputEvent.CTRL_MASK),
  	        javax.swing.text.DefaultEditorKit.pasteAction),
  	       new javax.swing.text.JTextComponent.KeyBinding(
  	    		  javax.swing.KeyStroke.getKeyStroke
  	         (java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.CTRL_MASK),
  	        javax.swing.text.DefaultEditorKit.cutAction),
 	     };
    
}
